For AI agents: A markdown version of this page is available at https://docs.datadoghq.com/api/latest/application-security/update-a-waf-policy.md. A documentation index is available at /llms.txt.

Update a WAF Policy

PUT https://api.ap1.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.ap2.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.datadoghq.eu/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.ddog-gov.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.us2.ddog-gov.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.uk1.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.us3.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}https://api.us5.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/{policy_id}

Overview

Update a specific WAF policy. Returns the policy object when the request is successful.

Arguments

Path Parameters

Name

Type

Description

policy_id [required]

string

The ID of the policy.

Request

Body Data (required)

New WAF policy.

Expand All

Field

Type

Description

data [required]

object

Object for a single WAF policy.

attributes [required]

object

Update a WAF policy.

description [required]

string

Description of the WAF policy.

isDefault [required]

boolean

Make this policy the default policy. The default policy is applied to every service not specifically assigned to another policy.

name [required]

string

The name of the WAF policy.

protectionPresets [required]

[string]

Presets enabled on this policy.

rules [required]

[object]

Rule overrides applied by the policy.

blocking [required]

boolean

When blocking is enabled, the rule will block the traffic matched by this rule.

enabled [required]

boolean

When false, this rule will not match any traffic.

extended_data_collection

boolean

When true, collects additional data from the WAF for this rule.

id [required]

string

Override the parameters for this WAF rule identifier.

rulesets

[object]

DEPRECATED: Deprecated: Ruleset overrides. Use protectionPresets instead.

blocking [required]

boolean

When blocking is enabled, the ruleset will block the traffic it matches.

enabled [required]

boolean

When false, this ruleset will not match any traffic.

id [required]

string

The identifier of the ruleset to override.

scope [required]

[object]

The scope of the WAF policy.

env [required]

string

The environment scope for the WAF policy.

service [required]

string

The service scope for the WAF policy.

version [required]

int64

Version of the WAF ruleset maintained by Datadog used by this policy. 0 is the default value.

type [required]

enum

The type of the resource. The value should always be policy. Allowed enum values: policy

default: policy

{
  "data": {
    "attributes": {
      "description": "Policy applied to internal web applications.",
      "isDefault": false,
      "name": "Internal Network Policy",
      "protectionPresets": [
        "attack-tools"
      ],
      "rules": [
        {
          "blocking": false,
          "enabled": true,
          "extended_data_collection": false,
          "id": "rasp-001-002"
        }
      ],
      "rulesets": [
        {
          "blocking": false,
          "enabled": true,
          "id": "attack_tool"
        }
      ],
      "scope": [
        {
          "env": "prod",
          "service": "billing-service"
        }
      ],
      "version": 0
    },
    "type": "policy"
  }
}

Response

OK

Response object that includes a single WAF policy.

Expand All

Field

Type

Description

data

object

Object for a single WAF policy.

attributes

object

A WAF policy.

description [required]

string

Description of the WAF policy.

isDefault

boolean

Make this policy the default policy. The default policy is applied to every service not specifically assigned to another policy.

name [required]

string

The name of the WAF policy.

protectionPresets

[string]

Presets enabled on this policy.

rules

[object]

Rule overrides applied by the policy.

blocking [required]

boolean

When blocking is enabled, the rule will block the traffic matched by this rule.

enabled [required]

boolean

When false, this rule will not match any traffic.

extended_data_collection

boolean

When true, collects additional data from the WAF for this rule.

id [required]

string

Override the parameters for this WAF rule identifier.

rulesets

[object]

DEPRECATED: Deprecated: Ruleset overrides. Use protectionPresets instead.

blocking [required]

boolean

When blocking is enabled, the ruleset will block the traffic it matches.

enabled [required]

boolean

When false, this ruleset will not match any traffic.

id [required]

string

The identifier of the ruleset to override.

scope

[object]

The scope of the WAF policy.

env [required]

string

The environment scope for the WAF policy.

service [required]

string

The service scope for the WAF policy.

version

int64

Version of the WAF ruleset maintained by Datadog used by this policy. 0 is the default value.

id

string

The ID of the policy.

meta

object

Metadata associated with the WAF policy.

added_at

date-time

The date and time the WAF policy was created.

added_by

string

The handle of the user who created the WAF policy.

added_by_name

string

The name of the user who created the WAF policy.

modified_at

date-time

The date and time the WAF policy was last updated.

modified_by

string

The handle of the user who last updated the WAF policy.

modified_by_name

string

The name of the user who last updated the WAF policy.

type

enum

The type of the resource. The value should always be policy. Allowed enum values: policy

default: policy

{
  "data": {
    "attributes": {
      "description": "Policy applied to internal web applications.",
      "isDefault": false,
      "name": "Internal Network Policy",
      "protectionPresets": [
        "attack-tools"
      ],
      "rules": [
        {
          "blocking": false,
          "enabled": true,
          "extended_data_collection": false,
          "id": "rasp-001-002"
        }
      ],
      "rulesets": [
        {
          "blocking": false,
          "enabled": true,
          "id": "attack_tool"
        }
      ],
      "scope": [
        {
          "env": "prod",
          "service": "billing-service"
        }
      ],
      "version": 0
    },
    "id": "2857c47d-1e3a-4300-8b2f-dc24089c084b",
    "meta": {
      "added_at": "2021-01-01T00:00:00Z",
      "added_by": "john.doe@datadoghq.com",
      "added_by_name": "John Doe",
      "modified_at": "2021-01-01T00:00:00Z",
      "modified_by": "john.doe@datadoghq.com",
      "modified_by_name": "John Doe"
    },
    "type": "policy"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Not Authorized

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Concurrent Modification

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  ## default
# 

# Path parameters
export policy_id="recommended"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/remote_config/products/asm/waf/policies/${policy_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "description": "Policy applied to internal web applications.", "isDefault": false, "name": "Internal Network Policy", "protectionPresets": [ "attack-tools" ], "rules": [ { "blocking": false, "enabled": true, "id": "rasp-001-002" } ], "scope": [ { "env": "prod", "service": "billing-service" } ], "version": 0 }, "type": "policy" } } EOF
"""
Update a WAF Policy returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.application_security_api import ApplicationSecurityApi
from datadog_api_client.v2.model.application_security_policy_rule_override import ApplicationSecurityPolicyRuleOverride
from datadog_api_client.v2.model.application_security_policy_ruleset_override import (
    ApplicationSecurityPolicyRulesetOverride,
)
from datadog_api_client.v2.model.application_security_policy_scope import ApplicationSecurityPolicyScope
from datadog_api_client.v2.model.application_security_policy_type import ApplicationSecurityPolicyType
from datadog_api_client.v2.model.application_security_policy_update_attributes import (
    ApplicationSecurityPolicyUpdateAttributes,
)
from datadog_api_client.v2.model.application_security_policy_update_data import ApplicationSecurityPolicyUpdateData
from datadog_api_client.v2.model.application_security_policy_update_request import (
    ApplicationSecurityPolicyUpdateRequest,
)

body = ApplicationSecurityPolicyUpdateRequest(
    data=ApplicationSecurityPolicyUpdateData(
        attributes=ApplicationSecurityPolicyUpdateAttributes(
            description="Policy applied to internal web applications.",
            is_default=False,
            name="Internal Network Policy",
            protection_presets=[
                "attack-tools",
            ],
            rules=[
                ApplicationSecurityPolicyRuleOverride(
                    blocking=False,
                    enabled=True,
                    extended_data_collection=False,
                    id="rasp-001-002",
                ),
            ],
            rulesets=[
                ApplicationSecurityPolicyRulesetOverride(
                    blocking=False,
                    enabled=True,
                    id="attack_tool",
                ),
            ],
            scope=[
                ApplicationSecurityPolicyScope(
                    env="prod",
                    service="billing-service",
                ),
            ],
            version=0,
        ),
        type=ApplicationSecurityPolicyType.POLICY,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = ApplicationSecurityApi(api_client)
    response = api_instance.update_application_security_waf_policy(policy_id="policy_id", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Update a WAF Policy returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::ApplicationSecurityAPI.new

body = DatadogAPIClient::V2::ApplicationSecurityPolicyUpdateRequest.new({
  data: DatadogAPIClient::V2::ApplicationSecurityPolicyUpdateData.new({
    attributes: DatadogAPIClient::V2::ApplicationSecurityPolicyUpdateAttributes.new({
      description: "Policy applied to internal web applications.",
      is_default: false,
      name: "Internal Network Policy",
      protection_presets: [
        "attack-tools",
      ],
      rules: [
        DatadogAPIClient::V2::ApplicationSecurityPolicyRuleOverride.new({
          blocking: false,
          enabled: true,
          extended_data_collection: false,
          id: "rasp-001-002",
        }),
      ],
      rulesets: [
        DatadogAPIClient::V2::ApplicationSecurityPolicyRulesetOverride.new({
          blocking: false,
          enabled: true,
          id: "attack_tool",
        }),
      ],
      scope: [
        DatadogAPIClient::V2::ApplicationSecurityPolicyScope.new({
          env: "prod",
          service: "billing-service",
        }),
      ],
      version: 0,
    }),
    type: DatadogAPIClient::V2::ApplicationSecurityPolicyType::POLICY,
  }),
})
p api_instance.update_application_security_waf_policy("policy_id", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Update a WAF Policy returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ApplicationSecurityPolicyUpdateRequest{
		Data: datadogV2.ApplicationSecurityPolicyUpdateData{
			Attributes: datadogV2.ApplicationSecurityPolicyUpdateAttributes{
				Description: "Policy applied to internal web applications.",
				IsDefault:   false,
				Name:        "Internal Network Policy",
				ProtectionPresets: []string{
					"attack-tools",
				},
				Rules: []datadogV2.ApplicationSecurityPolicyRuleOverride{
					{
						Blocking:               false,
						Enabled:                true,
						ExtendedDataCollection: datadog.PtrBool(false),
						Id:                     "rasp-001-002",
					},
				},
				Rulesets: []datadogV2.ApplicationSecurityPolicyRulesetOverride{
					{
						Blocking: false,
						Enabled:  true,
						Id:       "attack_tool",
					},
				},
				Scope: []datadogV2.ApplicationSecurityPolicyScope{
					{
						Env:     "prod",
						Service: "billing-service",
					},
				},
				Version: 0,
			},
			Type: datadogV2.APPLICATIONSECURITYPOLICYTYPE_POLICY,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewApplicationSecurityApi(apiClient)
	resp, r, err := api.UpdateApplicationSecurityWafPolicy(ctx, "policy_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ApplicationSecurityApi.UpdateApplicationSecurityWafPolicy`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ApplicationSecurityApi.UpdateApplicationSecurityWafPolicy`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Update a WAF Policy returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ApplicationSecurityApi;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyResponse;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyRuleOverride;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyRulesetOverride;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyScope;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyType;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyUpdateAttributes;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyUpdateData;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyUpdateRequest;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    ApplicationSecurityApi apiInstance = new ApplicationSecurityApi(defaultClient);

    ApplicationSecurityPolicyUpdateRequest body =
        new ApplicationSecurityPolicyUpdateRequest()
            .data(
                new ApplicationSecurityPolicyUpdateData()
                    .attributes(
                        new ApplicationSecurityPolicyUpdateAttributes()
                            .description("Policy applied to internal web applications.")
                            .isDefault(false)
                            .name("Internal Network Policy")
                            .protectionPresets(Collections.singletonList("attack-tools"))
                            .rules(
                                Collections.singletonList(
                                    new ApplicationSecurityPolicyRuleOverride()
                                        .blocking(false)
                                        .enabled(true)
                                        .extendedDataCollection(false)
                                        .id("rasp-001-002")))
                            .rulesets(
                                Collections.singletonList(
                                    new ApplicationSecurityPolicyRulesetOverride()
                                        .blocking(false)
                                        .enabled(true)
                                        .id("attack_tool")))
                            .scope(
                                Collections.singletonList(
                                    new ApplicationSecurityPolicyScope()
                                        .env("prod")
                                        .service("billing-service")))
                            .version(0L))
                    .type(ApplicationSecurityPolicyType.POLICY));

    try {
      ApplicationSecurityPolicyResponse result =
          apiInstance.updateApplicationSecurityWafPolicy("recommended", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling ApplicationSecurityApi#updateApplicationSecurityWafPolicy");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Update a WAF Policy returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_application_security::ApplicationSecurityAPI;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyRuleOverride;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyRulesetOverride;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyScope;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyType;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyUpdateAttributes;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyUpdateData;
use datadog_api_client::datadogV2::model::ApplicationSecurityPolicyUpdateRequest;

#[tokio::main]
async fn main() {
    let body =
        ApplicationSecurityPolicyUpdateRequest::new(ApplicationSecurityPolicyUpdateData::new(
            ApplicationSecurityPolicyUpdateAttributes::new(
                "Policy applied to internal web applications.".to_string(),
                false,
                "Internal Network Policy".to_string(),
                vec!["attack-tools".to_string()],
                vec![ApplicationSecurityPolicyRuleOverride::new(
                    false,
                    true,
                    "rasp-001-002".to_string(),
                )
                .extended_data_collection(false)],
                vec![ApplicationSecurityPolicyScope::new(
                    "prod".to_string(),
                    "billing-service".to_string(),
                )],
                0,
            )
            .rulesets(vec![ApplicationSecurityPolicyRulesetOverride::new(
                false,
                true,
                "attack_tool".to_string(),
            )]),
            ApplicationSecurityPolicyType::POLICY,
        ));
    let configuration = datadog::Configuration::new();
    let api = ApplicationSecurityAPI::with_config(configuration);
    let resp = api
        .update_application_security_waf_policy("policy_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Update a WAF Policy returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
const apiInstance = new v2.ApplicationSecurityApi(configuration);

const params: v2.ApplicationSecurityApiUpdateApplicationSecurityWafPolicyRequest =
  {
    body: {
      data: {
        attributes: {
          description: "Policy applied to internal web applications.",
          isDefault: false,
          name: "Internal Network Policy",
          protectionPresets: ["attack-tools"],
          rules: [
            {
              blocking: false,
              enabled: true,
              extendedDataCollection: false,
              id: "rasp-001-002",
            },
          ],
          rulesets: [
            {
              blocking: false,
              enabled: true,
              id: "attack_tool",
            },
          ],
          scope: [
            {
              env: "prod",
              service: "billing-service",
            },
          ],
          version: 0,
        },
        type: "policy",
      },
    },
    policyId: "policy_id",
  };

apiInstance
  .updateApplicationSecurityWafPolicy(params)
  .then((data: v2.ApplicationSecurityPolicyResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"